OSDN Git Service

[IMPROVED] The automatic resolution of installation conflict is improved to detect...
[portsreinstall/current.git] / bin / portsreinstall
1 #!/bin/sh -e
2 # ==================================================================================
3 # portsreinstall main script
4 # Copyright (C) 2010-2014 Mamoru Sakaue, MwGhennndo, All Rights Reserved.
5 # This software is distributed under the 2-Clause BSD License.
6 # ==================================================================================
7
8 # ==================================================
9 # ================== ENVIRONMENT ===================
10 # ==================================================
11
12 # ============ Set up of environment =============
13 APPNAME=`basename "$0"`
14
15 # MYVERSION=3.1.0
16 # COMPATIBLE_VERSIONS='^(3\.1\.[0-9]+)$'
17 # Template for development versions
18 MYVERSION=3.1.0+toward_3.1.1_20141203232814
19 COMPATIBLE_VERSIONS='^(3\.0\.[0-9]+\+toward_3\.1\.[0-9]+_[0-9]+|3\.0\.[0-9]+\+toward_3\.0\.[0-9]+_[0-9]+|3\.1\.[0-9]+)$'
20 MYPREFIX=`dirname "\`dirname \"$0\"\`" | sed 's|/bin$||'`
21 MYPREFIX=${MYPREFIX:-/usr/local}
22 LIBDIR=${MYPREFIX}/lib/${APPNAME}
23
24 . ${LIBDIR}/libtemp.sh
25 . ${LIBDIR}/libstr.sh
26 . ${LIBDIR}/liboptions.sh
27 . ${LIBDIR}/libusage.sh
28 . ${LIBDIR}/libmessage.sh
29 . ${LIBDIR}/libpkgsys.sh
30 . ${LIBDIR}/libmisc.sh
31 . ${LIBDIR}/libfileedit.sh
32 . ${LIBDIR}/libconf.sh
33 . ${LIBDIR}/libdatabase_build.sh
34 . ${LIBDIR}/libdatabase_query.sh
35 . ${LIBDIR}/libdatabase_record.sh
36 . ${LIBDIR}/libcommand.sh
37 . ${LIBDIR}/libprogram.sh
38 . ${LIBDIR}/libreinstall.sh
39 . ${LIBDIR}/libdeinstall.sh
40
41 misc_init_vardefs
42 temp_trap_init
43 DBDIR=/var/tmp/${APPNAME}.db
44 CONFFILE=${MYPREFIX}/etc/${APPNAME}.conf
45 PKGTOOLSCONF=${MYPREFIX}/etc/pkgtools.conf
46
47 # ==================================================
48 # ========= PARSING OPTIONS AND ARGUMENTS ==========
49 # ==================================================
50
51 # ============= Save arguments for upgraded restart =============
52 options_dump_args "$@" > ${TMPDIR}/restart_command.sh
53
54 # ============= Option check =============
55 options_set_default
56
57 options_getopts "$@" || :
58 if [ $OPTIONS_ERRNO -eq 2 ]
59 then
60         message_echo "INTERNAL ERROR: In parsing options" >&2
61         exit 1
62 fi
63 shift "${OPTIONS_SHIFT}"
64
65 # ============= Argument check for no-command options =============
66 if [ $opt_help_mode -ne 0 -o $opt_show_version = yes ]
67 then
68         if [ $# -gt 0 ]
69         then
70                 OPTIONS_ERRNO=1
71         fi
72 fi
73
74 # ============= Output usage if the case of a help mode or option/argument errors =============
75 if [ $OPTIONS_ERRNO -ne 0 ]
76 then
77         exit $OPTIONS_ERRNO
78 elif [ $opt_help_mode -eq 1 ]
79 then
80         usage_short
81         exit
82 elif [ $opt_help_mode -eq 2 ]
83 then
84         usage_long | less -r
85         exit
86 fi
87
88 # ============= Output version number =============
89 if [ $opt_show_version = yes ]
90 then
91         message_version
92         exit
93 fi
94
95 # ============= Set up variables for environment of ports and packages =============
96 conf_setup_ports_envs
97 conf_setup_packages_envs
98
99 # ============= Execute command operations before getting the temporary database ready =============
100 command_exec_before_db_creation "$@"
101
102 # ============= Creation of temporary database directory =============
103 database_build_create
104
105 # ============= Argument check for conventional runs =============
106 command_parse_args "$@"
107 shift "${COMMAND_SHIFT}"
108
109
110 # ==================================================
111 # ================== TOOLS SET UP ==================
112 # ==================================================
113
114 # ============= Termination messages during construction of the temporary database =============
115
116 # Set termination messages
117 temp_terminate_process_common ()
118 {
119         local msg_where
120         [ $opt_batch_mode = yes ] && return
121         msg_where=`temp_get_msg_current_stage`
122         [ -n "$msg_where" ] && msg_where=" during $msg_where"
123         echo
124         if [ $errno -eq 130 ]
125         then
126                 echo "INFO: Terminated at `message_timestamp`$msg_where."
127                 echo
128                 echo " You can restart this process from the terminated point by"
129         else
130                 echo "INFO: Aborted at `message_timestamp`$msg_where."
131                 echo
132                 echo " You may restart this process from the aborted point by"
133         fi
134         echo "executing without options or arguments as:"
135         if [ -n "$COMMAND_RESTART" ]
136         then
137                 echo "  ${APPNAME} $COMMAND_RESTART"
138         else
139                 echo "  ${APPNAME}"
140         fi
141 }
142
143 temp_terminate_process ()
144 {
145         local tmp_msg
146         tmp_msg=${TMPDIR}/temp_terminate_process:msg
147         [ $errno -eq 0 -o $opt_batch_mode = yes ] && return
148         temp_terminate_process_common
149         [ -n "$COMMAND_RESTART" ] && return
150         cat > $tmp_msg << eof
151  Instead, if you only want to construct the temporary database so as to stop before the actual reinstallation, execute as:
152   ${APPNAME} prepare
153 eof
154         message_cat "$tmp_msg"
155 }
156
157 # ============= Opening title =============
158
159 message_credit
160 [ $COMMAND_MODE = do -o $COMMAND_MODE = redo -o $COMMAND_MODE = forget ] && \
161         message_opening_notice
162 message_echo
163
164 # ============= Execute command operations which do not need package tools =============
165
166 command_exec_without_pkgtools "$@"
167 misc_is_superuser_privilege && touch "${DBDIR}/in_use"
168
169 # ============= Definition of environment dependent functions =============
170
171 pkgsys_def_pkgtools
172
173 # ============= Option settings =============
174
175 # Execute command operations which are not affected by saved option settings
176 command_exec_irrespective_of_saved_options "$@"
177
178 # Load, renew and save option values
179 optcomb_err=0
180 options_chk_invalid_optvals_renewal non_renewable || optcomb_err=$?
181 if [ \( $opt_reload_conf = yes -o $opt_reset_targets = yes \) -a "x$COMMAND_MODE" != xredo ]
182 then
183         message_echo "ERROR: Options -L and -N are available only in the initial run of redo command." >&2
184         message_echo >&2
185         optcomb_err=1
186 fi
187 if [ $opt_batch_ports_only = yes -a $opt_interactive_ports_only = yes ]
188 then
189         message_echo "ERROR: Options -A and -I conflict with each other." >&2
190         message_echo >&2
191         optcomb_err=1
192 fi
193 if [ -e "${DBDIR}/saved_options.sh" ]
194 then
195         {
196                 options_renewed_optvals M renewable_anytime || optcomb_err=$?
197                 options_renewed_optvals N renewable_in_redo_on_target || optcomb_err=$?
198                 options_renewed_optvals L renewable_in_redo_on_conf || optcomb_err=$?
199         } > ${TMPDIR}/renewed_optvals.sh
200         [ $optcomb_err -eq 0 ] || exit $optcomb_err
201         . "${DBDIR}/saved_options.sh"
202         . "${TMPDIR}/renewed_optvals.sh"
203 fi
204 misc_is_superuser_privilege && misc_get_all_vardefs | options_filter saved > ${DBDIR}/saved_options.sh
205
206 # Show option values
207 if [ -e "${DBDIR}/saved_options.sh" -a $opt_batch_mode = no \
208         -a \( $COMMAND_MODE = do -o $COMMAND_MODE = redo \) ]
209 then
210         message_echo "INFO: List of option values:"
211         message_echo "-----------------------------------------"
212         message_cat "${DBDIR}/saved_options.sh"
213         message_echo "-----------------------------------------"
214         message_echo
215 fi
216
217 # ============= Configurations =============
218
219 # Save the previous configuration if exists
220 PROGRAM_DEPENDS=''
221 _program_exec_and_record_completion__operation ()
222 {
223         rm -rf "${DBDIR}/conf.prev"
224         [ -d "${DBDIR}/conf" ] && \
225                 cp -Rp "${DBDIR}/conf" "${DBDIR}/conf.prev"
226         :
227 }
228 program_exec_and_record_completion SAVE_PREV_CONF
229
230 # Get complete configuration variable definitions by importing pkgtools.conf(5) if available
231 PROGRAM_DEPENDS='SAVE_PREV_CONF'
232 _program_exec_and_record_completion__operation ()
233 {
234         local need_msg
235         need_msg=no
236         rm -rf "${DBDIR}/conf"
237         mkdir -p "${DBDIR}/conf"
238         [ "x`options_get_effective_opt_load_pkgtoolsconf 2> /dev/null`" != xno -a $opt_batch_mode = no ] \
239                 && need_msg=yes
240         [ $need_msg = yes ] && \
241                 message_section_title "Parsing pkgtools.conf (by using installed portupgrade)"
242         conf_get_complete_var_defs > ${DBDIR}/conf/complete_setup.sh
243         [ $need_msg = yes ] &&  { message_echo "===> ok"; message_echo; }
244         :
245 }
246 program_exec_and_record_completion GET_COMPLETE_CONF_VAR_DEF
247
248 # Parse the configuration
249 PROGRAM_DEPENDS='GET_COMPLETE_CONF_VAR_DEF'
250 _program_exec_and_record_completion__operation ()
251 {
252         message_section_title "Parsing the configuration"
253         conf_manipulate_available_var_defs
254         . "${DBDIR}/conf/manipulated_defs.sh"
255         # ALT_MOVED_*
256         conf_build_effective_MOVED
257         # Environmental variables
258         conf_setup_effective_env > ${DBDIR}/conf/setenv.sh
259         . "${DBDIR}/conf/setenv.sh"
260         # HOLD_*
261         conf_parse_vars_for_each_port_glob HOLD
262         str_escape_regexp_filter < ${DBDIR}/conf/HOLD:PORTS.parsed \
263                 | sed 's/^/^/;s/$/$/' > ${DBDIR}/conf/HOLD_PORTS.grep_pattern
264         # TABOO_*
265         conf_parse_vars_for_each_port_glob TABOO
266         fileedit_combine_lists "${DBDIR}/conf/TABOO:PORTS.parsed" "${DBDIR}/taboo.list" \
267                 > ${DBDIR}/taboo.all.list
268         # NOPKG_*
269         conf_parse_vars_for_each_port_glob NOPKG
270         # REPLACE_*
271         conf_build_replacement_patterns_from_REPLACE
272         # MARG_*
273         conf_parse_vars_for_each_port_glob_with_bound_val MARG TARGET DEF
274         # MENV_*
275         conf_parse_vars_for_each_port_glob_with_bound_val MENV TARGET DEF
276         # BEFOREBUILD_*
277         conf_parse_vars_for_each_port_glob_with_bound_val BEFOREBUILD TARGET COMMAND
278         # BEFOREDEINSTALL_*
279         conf_parse_vars_for_each_port_glob_with_bound_val BEFOREDEINSTALL TARGET COMMAND
280         # AFTERINSTALL_*
281         conf_parse_vars_for_each_port_glob_with_bound_val AFTERINSTALL TARGET COMMAND
282         message_echo
283 }
284 program_exec_and_record_completion PARSE_CONF
285
286 . "${DBDIR}/conf/setenv.sh"
287
288 # ============= Upgrade of tools =============
289
290 # Execute command operations which should be done without upgrade of tools
291 command_exec_before_tools_upgrade "$@"
292
293 # Check whether the temporary database is newer than the ports tree and refresh if so
294 database_build_refresh_if_obsolete
295
296 # Get the port origin for this utility if installed by port
297 MYPORTORIGIN=`pkgsys_get_my_origin 2> /dev/null` || :
298
299 # Collect all installed packages
300 PROGRAM_DEPENDS=''
301 _program_exec_and_record_completion__operation ()
302 {
303         local tmp_installed_ports tmp_installed_pkgs
304         message_section_title "Collecting all installed packages"
305         if [ -e "${DBDIR}/installed_ports.inspected" ]
306         then
307                 if ! [ "${DBDIR}/installed_ports" -ot "${DBDIR}/initial" -a "${DBDIR}/installed_ports:pkg_vs_origin.tbl" -ot "${DBDIR}/initial" ]
308                 then
309                         find "${DBDIR}/initial" -depth 2 -type d \
310                                 | sed -E 's|.*/([^/]+/[^/]+)$|\1|' > ${DBDIR}/installed_ports || :
311                         while read origin
312                         do
313                                 pkg=`cat "${DBDIR}/initial/$origin/installed_version" 2>/dev/null` || continue
314                                 printf '%s\t%s\n' "$origin" "$pkg"
315                         done < ${DBDIR}/installed_ports > ${DBDIR}/installed_ports:pkg_vs_origin.tbl
316                 fi
317         else
318                 pkg_info_qoa > ${DBDIR}/installed_ports
319                 pkg_info_gen_pkg_origin_table
320         fi
321         str_escape_regexp_filter < "${DBDIR}/installed_ports" \
322                 | sed 's/^/^/; s/$/$/' > ${DBDIR}/installed_ports.grep_pattern
323         message_echo
324 }
325 program_exec_and_record_completion COLLECT_ALL_INSTALLED_PACKAGES
326
327 # Preliminary inspection of tools which have to be up-to-date
328 # (No need depend on PARSE_CONF because INSPECT_ALL_DEPENDENCIES will take the task.)
329 PROGRAM_DEPENDS=
330 _program_exec_restartable_loop_operation__routine ()
331 {
332         local origin
333         origin=$1
334         database_build_inspect_dependencies "$origin"
335 }
336 _program_exec_and_record_completion__operation ()
337 {
338         local DEPTH_INDEX
339         message_section_title "Preliminary inspection of tools which have to be up-to-date"
340         {
341                 [ "$PKGSYS_USE_PKGNG" = yes ] && echo 'ports-mgmt/pkg'
342                 pkgsys_is_dialog4ports_used && echo 'ports-mgmt/dialog4ports'
343                 [ -n "$MYPORTORIGIN" ] && echo "$MYPORTORIGIN"
344         } 2> /dev/null > ${DBDIR}/stage.loop_list/tools_to_inspect
345         DEPTH_INDEX='--'
346         program_exec_restartable_loop_operation tools_to_inspect
347         database_build_post_inspect_dependencies
348         message_echo
349 }
350 program_exec_and_record_completion PRELIMINARY_INSPECTION_OF_TOOLS
351
352 # Upgrade of ports-mgmt/pkg if new
353 # (No need depend on PARSE_CONF because REINSTALLATION will take the task.)
354 if [ \( "$COMMAND_MODE" = do -o "$COMMAND_MODE" = redo \) \
355         -a $opt_dry_run = no -a $opt_suppress_pkgtools_upadte = no \
356         -a "$PKGSYS_USE_PKGNG" = yes ]
357 then
358         PROGRAM_DEPENDS='PRELIMINARY_INSPECTION_OF_TOOLS'
359         _program_exec_and_record_completion__operation ()
360         {
361                 local _MSG_CURRENT_STAGE_general
362                 _MSG_CURRENT_STAGE_general="pkgng upgrade"
363                 temp_set_msg_current_stage "${_MSG_CURRENT_STAGE_general}"
364                 message_section_title "Upgrade of ports-mgmt/pkg if new"
365                 touch "${DBDIR}/target_all"
366                 reinstall_exec ports-mgmt/pkg
367                 reinstall_restore_conflicts
368                 rm -f "${DBDIR}/target_all"
369                 temp_set_msg_current_stage
370                 message_echo
371         }
372         program_exec_and_record_completion UPGRADE_PKGNG
373 fi
374
375 # Upgrade of ports-mgmt/dialog4ports if new
376 # (No need depend on PARSE_CONF because REINSTALLATION will take the task.)
377 if [ \( "$COMMAND_MODE" = do -o "$COMMAND_MODE" = redo \) \
378         -a $opt_dry_run = no -a $opt_suppress_pkgtools_upadte = no ] \
379         && pkgsys_is_dialog4ports_used
380 then
381         PROGRAM_DEPENDS='PRELIMINARY_INSPECTION_OF_TOOLS'
382         _program_exec_and_record_completion__operation ()
383         {
384                 local _MSG_CURRENT_STAGE_general
385                 _MSG_CURRENT_STAGE_general="pkgng dialog4ports"
386                 temp_set_msg_current_stage "${_MSG_CURRENT_STAGE_general}"
387                 message_section_title "Upgrade of dialog4ports if new"
388                 touch "${DBDIR}/target_all"
389                 reinstall_exec ports-mgmt/dialog4ports
390                 reinstall_restore_conflicts
391                 rm -f "${DBDIR}/target_all"
392                 temp_set_msg_current_stage
393                 message_echo
394         }
395         program_exec_and_record_completion UPGRADE_DIALOG4PORTS
396 fi
397
398 # Upgrade of this utility if new
399 # (No need depend on PARSE_CONF because REINSTALLATION will take the task.)
400 if [ \( "$COMMAND_MODE" = do -o "$COMMAND_MODE" = redo \) \
401         -a $opt_dry_run = no -a $opt_suppress_self_upadte = no \
402         -a -n "$MYPORTORIGIN" ]
403 then
404         PROGRAM_DEPENDS='PRELIMINARY_INSPECTION_OF_TOOLS'
405         _program_exec_and_record_completion__operation ()
406         {
407                 local _MSG_CURRENT_STAGE_general
408                 _MSG_CURRENT_STAGE_general="pkgng upgrade"
409                 temp_set_msg_current_stage "${_MSG_CURRENT_STAGE_general}"
410                 message_section_title "Upgrade of this utility if new"
411                 touch "${DBDIR}/target_all"
412                 reinstall_exec "$MYPORTORIGIN"
413                 reinstall_restore_conflicts
414                 rm -f "${DBDIR}/target_all"
415                 temp_set_msg_current_stage
416                 message_echo
417         }
418         program_exec_and_record_completion UPGRADE_SELF
419 fi
420
421 if [ "x`${APPNAME} -aV 2> /dev/null`" != "x$MYVERSION" ]
422 then
423         message_echo "INFO: ${APPNAME} is upgraded and the temporary database needs refresh."
424         database_build_clean_for_self_upgrade || :
425         message_echo "INFO: Restarting with the new version."
426         message_echo
427         temp_trap_for_invoking_new_version
428         . "${TMPDIR}"/restart_command.sh
429         exit
430 fi
431
432
433 # ==================================================
434 # ================== PREPARATION ===================
435 # ==================================================
436
437 # ============= Correspondence to configuration changes =============
438
439 # Patch to the temporary database by reflecting changes in configuration
440 PROGRAM_DEPENDS='PARSE_CONF'
441 _program_exec_and_record_completion__operation ()
442 {
443         local tmpfile_diff tmpfile_old tmpfile_new key
444         [ -d "${DBDIR}/conf.prev" ] || return 0
445         message_section_title "Patch to the temporary database by reflecting changes in configuration"
446         tmpfile_old=${TMPDIR}/PATCH_TO_TMPDB_REFLECT_CONF_CHANGES::old
447         tmpfile_new=${TMPDIR}/PATCH_TO_TMPDB_REFLECT_CONF_CHANGES::new
448         tmpfile_updated_ports=${TMPDIR}/PATCH_TO_TMPDB_REFLECT_CONF_CHANGES::updated_ports
449         if fileedit_manipulate_old_new_lines \
450                 "${DBDIR}/conf.prev/setenv.sh" "${DBDIR}/conf/setenv.sh" "$tmpfile_old" "$tmpfile_new"
451         then
452                 if grep -q -e ^LOCALBASE= -e ^LINUXBASE= -e ^PORTSDIR= "$tmpfile_old" "$tmpfile_new"
453                 then
454                         message_echo "ERROR: Migration of the temporary database is unavailable because LOCALBASE, LINUXBASE or PORTSDIR was changed." >&2
455                         message_echo "        ${APPNAME} clean" >&2
456                         message_echo "must be executed in advance." >&2
457                         exit 1
458                 fi
459         fi
460         cut -s -d '|' -f 1,2 "${DBDIR}/conf.prev/MOVED_ALT.parsed" | tr '|' '\t' > ${TMPDIR}/MOVED_ALT.old
461         cut -s -d '|' -f 1,2 "${DBDIR}/conf/MOVED_ALT.parsed" | tr '|' '\t' > ${TMPDIR}/MOVED_ALT.new
462         if fileedit_manipulate_old_new_lines \
463                 "${TMPDIR}/MOVED_ALT.old" "${TMPDIR}/MOVED_ALT.new" "$tmpfile_old" "$tmpfile_new"
464         then
465                 cat "$tmpfile_old" "$tmpfile_new" | while read from to
466                 do
467                         echo "$from"
468                         [ -n "$to" ] && echo "$to"
469                 done
470         fi > $tmpfile_updated_ports
471         sort -u "${DBDIR}/conf/NOPKG:PORTS.parsed" 2> /dev/null > ${TMPDIR}/NOPKG:PORTS.parsed.new || :
472         sort -u "${DBDIR}/conf.prev/NOPKG:PORTS.parsed" 2> /dev/null > ${TMPDIR}/NOPKG:PORTS.parsed.old || :
473         diff "${TMPDIR}/NOPKG:PORTS.parsed.old" "${TMPDIR}/NOPKG:PORTS.parsed.new" | sed -n 's/^[<>] //p' >> $tmpfile_updated_ports
474         if fileedit_manipulate_old_new_lines \
475                 "${DBDIR}/conf.prev/REPLACE.csv" "${DBDIR}/conf/REPLACE.csv" "$tmpfile_old" "$tmpfile_new"
476         then
477                 cat "$tmpfile_old" "$tmpfile_new" | while read from to
478                 do
479                         echo "$from"
480                         [ -n "$to" ] && echo "$to"
481                 done
482         fi >> $tmpfile_updated_ports
483         [ `wc -l < $tmpfile_updated_ports` -gt 0 ] && rm -f "${DBDIR}/REPLACE.complete_sed_pattern"
484         [ -d "${DBDIR}/conf/each_port" ] && find "${DBDIR}/conf/each_port" -depth 2 \
485                 | while read dbpath
486         do
487                 origin=`str_dirpath_to_origin "$dbpath"`
488                 dbpath_prev=${DBDIR}/conf.prev/each_port/$origin
489                 diff -r "$dbpath_prev" "$dbpath" > /dev/null 2>&1 && continue
490                 echo "$origin"
491         done >> $tmpfile_updated_ports
492         [ -d "${DBDIR}/conf.prev/each_port" ] && find "${DBDIR}/conf.prev/each_port" -depth 2 \
493                 | while read dbpath_prev
494         do
495                 origin=`str_dirpath_to_origin "$dbpath_prev"`
496                 dbpath=${DBDIR}/conf/each_port/$origin
497                 [ -d "$dbpath" ] && continue
498                 echo "$origin"
499         done >> $tmpfile_updated_ports
500         if [ `wc -l < $tmpfile_updated_ports` -gt 0 ]
501         then
502                 sort -u "$tmpfile_updated_ports" | while read origin
503                 do
504                         database_build_patch_reconf "$origin"
505                 done
506                 program_deregister_stage_complete INSPECT_ALL_DEPENDENCIES
507         fi
508         message_echo
509 }
510 program_exec_and_record_completion PATCH_TO_TMPDB_REFLECT_CONF_CHANGES
511
512 # ============= Database construction =============
513
514 # Execute command operations which must be done before building the temporary database
515 command_exec_before_building_tempdb "$@"
516
517 # Meta process for redo
518 PROGRAM_DEPENDS=''
519 _program_exec_and_record_completion__operation ()
520 {
521         rm -f "${DBDIR}/new_success_in_current_run"
522         [ "x$COMMAND_MODE" = xredo ] || return 0
523         message_echo "[REDO mode]"
524         message_echo
525 }
526 program_exec_and_record_completion REDO_INIT
527
528 # Determine specified targets
529 PROGRAM_DEPENDS=''
530 _program_exec_and_record_completion__operation ()
531 {
532         local tag level dbsuffix
533         message_section_title "Determining specified targets"
534         cat "${DBDIR}/stage.loop_list/target_itself.specified" \
535                 "${DBDIR}/stage.loop_list/target_dependents.specified" \
536                 "${DBDIR}/stage.loop_list/target_requirements.specified" \
537                 "${DBDIR}/need.list" \
538                 "${DBDIR}/targets_specified_so_far" 2> /dev/null \
539                 | sort -u > ${DBDIR}/targets_specified_so_far.tmp
540         mv "${DBDIR}/targets_specified_so_far.tmp" "${DBDIR}/targets_specified_so_far"
541         rm -f "${DBDIR}/stage.loop_list/target_itself.specified" \
542                 "${DBDIR}/stage.loop_list/target_dependents.specified" \
543                 "${DBDIR}/stage.loop_list/target_requirements.specified"
544         if [ -n "$opt_target_itself$opt_target_dependents$opt_target_requirements" ]
545         then
546                 options_select_new_ports_if_duplicated O \
547                         "${DBDIR}/stage.loop_list/target_itself.specified" "$opt_target_itself"
548                 options_select_new_ports_if_duplicated t \
549                         "${DBDIR}/stage.loop_list/target_dependents.specified" "$opt_target_dependents"
550                 options_select_new_ports_if_duplicated T \
551                         "${DBDIR}/stage.loop_list/target_requirements.specified" "$opt_target_requirements"
552                 if [ `cat "${DBDIR}/stage.loop_list/target_itself.specified" \
553                         "${DBDIR}/stage.loop_list/target_dependents.specified" \
554                         "${DBDIR}/stage.loop_list/target_requirements.specified" | wc -l` -eq 0 ]
555                 then
556                         message_echo "ERROR: No matching port for target globs." >&2
557                         message_echo >&2
558                         exit 1
559                 fi
560                 cat "${DBDIR}/stage.loop_list/target_itself.specified" \
561                         "${DBDIR}/stage.loop_list/target_dependents.specified" \
562                         "${DBDIR}/stage.loop_list/target_requirements.specified" \
563                         | sort -u > ${TMPDIR}/DETERMINE_SPECIFIED_TARGETS.reset
564                 cat "${TMPDIR}/DETERMINE_SPECIFIED_TARGETS.reset" "${DBDIR}/need.list" 2> /dev/null \
565                         | sort -u > ${DBDIR}/need.list.tmp
566                 mv "${DBDIR}/need.list.tmp" "${DBDIR}/need.list"
567                 sort -u "${DBDIR}/need.list" "${DBDIR}/targets_specified_so_far" \
568                         > ${DBDIR}/targets_specified_so_far.tmp
569                 mv "${DBDIR}/targets_specified_so_far.tmp" "${DBDIR}/targets_specified_so_far"
570                 for tag in all run build none
571                 do
572                         for level in direct full
573                         do
574                                 dbsuffix=$tag.$level
575                                 {
576                                         cat "${TMPDIR}/DETERMINE_SPECIFIED_TARGETS.reset"
577                                         cat "${DBDIR}/stage.loop_list/target_dependents.specified" | while read origin
578                                         do
579                                                 nodedir=${DBDIR}/requires/$origin
580                                                 cat "$nodedir/dependents.$dbsuffix" 2> /dev/null
581                                         done
582                                         cat "${DBDIR}/stage.loop_list/target_requirements.specified" | while read origin
583                                         do
584                                                 nodedir=${DBDIR}/requires/$origin
585                                                 cat "$nodedir/requirements.$dbsuffix" 2> /dev/null
586                                         done
587                                 } | sort -u | while read origin
588                                 do
589                                         fileedit_rm_a_line "$origin" "${DBDIR}/success.$dbsuffix.list"
590                                         fileedit_rm_a_line "$origin" "${DBDIR}/todo_after_requirements_succeed.$dbsuffix.list"
591                                         rm -f "${DBDIR}/requires/$origin/succeeded_once"
592                                 done
593                         done
594                 done
595         fi
596         message_echo
597 }
598 program_exec_and_record_completion DETERMINE_SPECIFIED_TARGETS
599
600 # Show specified targets
601 if [ -n "$opt_target_itself$opt_target_dependents$opt_target_requirements" -a $opt_batch_mode = no ]
602 then
603         message_echo "INFO: (Re/de-)installation will be carried out only for the targets:"
604         echo
605         if [ `wc -l < ${DBDIR}/stage.loop_list/target_itself.specified` -gt 0 ]
606         then
607                 message_echo "[Targets only]"
608                 echo "----------------------------------------"
609                 cat "${DBDIR}/stage.loop_list/target_itself.specified"
610                 echo "----------------------------------------"
611                 echo
612         fi
613         if [ `wc -l < ${DBDIR}/stage.loop_list/target_dependents.specified` -gt 0 ]
614         then
615                 message_echo "[Targets with their `options_get_dependency_msgterm` dependents]"
616                 echo "----------------------------------------"
617                 cat "${DBDIR}/stage.loop_list/target_dependents.specified"
618                 echo "----------------------------------------"
619                 echo
620         fi
621         if [ `wc -l < ${DBDIR}/stage.loop_list/target_requirements.specified` -gt 0 ]
622         then
623                 message_echo "[Targets with their `options_get_dependency_msgterm` requirements]"
624                 echo "----------------------------------------"
625                 cat "${DBDIR}/stage.loop_list/target_requirements.specified"
626                 echo "----------------------------------------"
627                 echo
628         fi
629 fi
630
631 # Determine all target ports
632 PROGRAM_DEPENDS='DETERMINE_SPECIFIED_TARGETS COLLECT_ALL_INSTALLED_PACKAGES'
633 _program_exec_and_record_completion__operation ()
634 {
635         message_section_title "Determining all target ports"
636         {
637                 if [ $opt_only_target_scope = no ]
638                 then
639                         cat "${DBDIR}/installed_ports" 2> /dev/null || :
640                 fi
641                 cat "${DBDIR}/stage.loop_list/target_itself.specified" || :
642                 cat "${DBDIR}/stage.loop_list/target_dependents.specified" || :
643                 cat "${DBDIR}/stage.loop_list/target_requirements.specified" || :
644                 cat "${DBDIR}/targets_specified_so_far" || :
645         }  2> /dev/null | sort -u > "${DBDIR}/stage.loop_list/ports_to_inspect"
646         message_echo
647 }
648 program_exec_and_record_completion DETERMINE_ALL_TARGET_PORTS
649
650 # Inspection of all dependencies
651 PROGRAM_DEPENDS='PARSE_CONF DETERMINE_ALL_TARGET_PORTS'
652 _program_exec_restartable_loop_operation__routine ()
653 {
654         local origin
655         origin=$1
656         database_build_inspect_dependencies "$origin"
657 }
658 _program_exec_and_record_completion__operation ()
659 {
660         local DEPTH_INDEX 
661         message_section_title "Inspecting dependencies of the all installed packages"
662         [ $opt_only_target_scope = no -a -n "$opt_target_itself$opt_target_dependents$opt_target_requirements" ] && \
663                 message_echo "INFO: Ports which seem irrelevant to the targets are also inspected in order to get complete information."
664         DEPTH_INDEX='--'
665         program_exec_restartable_loop_operation ports_to_inspect
666         database_build_post_inspect_dependencies
667         message_echo
668 }
669 program_exec_and_record_completion INSPECT_ALL_DEPENDENCIES
670
671 # Convert dependency-lists to actual ones
672 PROGRAM_DEPENDS='INSPECT_ALL_DEPENDENCIES'
673 _program_exec_restartable_loop_operation__routine ()
674 {
675         local origin table dbtag level tag target
676         origin=$1
677         for table in dependents requirements
678         do
679                 for dbtag in requires obsolete
680                 do
681                         for level in direct full
682                         do
683                                 for tag in all run build
684                                 do
685                                         target=${DBDIR}/$dbtag/$origin/${table}.${tag}.${level}
686                                         if [ -e "$target.src" ]
687                                         then
688                                                 sed -E -f "${DBDIR}/REPLACE.complete_sed_pattern" "$target.src" \
689                                                         | grep -v '^$' | sort -u > $target.tmp
690                                                 [ -e "$target" ] && ! diff "$target.tmp" "$target" > /dev/null \
691                                                         && echo "$origin" >> ${DBDIR}/update_dependencies
692                                                 mv "$target.tmp" "$target"
693                                         else
694                                                 [ -e "$target" ] && echo "$origin" >> ${DBDIR}/update_dependencies
695                                                 rm -f "$target"
696                                         fi
697                                 done
698                         done
699                 done
700         done
701 }
702 _program_exec_and_record_completion__operation ()
703 {
704         message_section_title "Conversion of dependency-lists to actual ones"
705         program_exec_restartable_loop_operation convert_dependency_lists
706         sort -u "${DBDIR}/update_dependencies" > ${DBDIR}/update_dependencies.tmp
707         mv "${DBDIR}/update_dependencies.tmp" "${DBDIR}/update_dependencies"
708         str_escape_regexp_filter < ${DBDIR}/update_dependencies \
709                 | sed 's/^/^/; s/$/$/' > ${DBDIR}/update_dependencies.grep_pattern
710         for tag in all run build
711         do
712                 ( cd "${DBDIR}/requires" && \
713                         find . -depth 3 -type f -name requirements.${tag}.full -or -name requirements.${tag}.full.orig ) \
714                         | sort -u \
715                         | sed 's|^./||;s|/[^/]*$||' \
716                         | grep -v -E -f "${DBDIR}/update_dependencies.grep_pattern" \
717                         | str_escape_regexp_filter | sed 's/^/^/; s/$/$/' \
718                         > ${TMPDIR}/convert_requirements_list:full_complete.grep_pattern || :
719                 ( cd "${DBDIR}/requires" && \
720                         find . -depth 3 -type f -name requirements.${tag}.direct -or -name requirements.${tag}.direct.orig ) \
721                         | sort -u \
722                         | sed 's|^./||;s|/[^/]*$||' \
723                         | grep -v -E -f "${TMPDIR}/convert_requirements_list:full_complete.grep_pattern" \
724                         > ${DBDIR}/stage.loop_list/complete_recursive_${tag}time_reqlists || :
725         done
726         for inspected_level_tmp in direct node
727         do
728                 cat "${DBDIR}/ports.inspected.${inspected_level_tmp}.list" || :
729         done 2> /dev/null | sort -u > ${DBDIR}/stage.loop_list/trim_dependency_lists_rm_uninspected_ports
730         find "${DBDIR}/requires" -depth 2 -type d > ${DBDIR}/stage.loop_list/inspect_dependent
731         [ -e "${DBDIR}/dependents_files" ] && \
732                 mv "${DBDIR}/dependents_files" "${DBDIR}/dependents_files.prev"
733         rm -f "${DBDIR}/stage.loop_list/make_dependents_lists_unique.tmp" "${DBDIR}/dependents_files.tmp"
734         message_echo
735 }
736 program_exec_and_record_completion CONVERT_REQUIREMENTS_LIST
737
738 # Completion of recursive requirement lists
739 for _REQUIREMENT_LISTS_tag in all run build
740 do
741         PROGRAM_DEPENDS='CONVERT_REQUIREMENTS_LIST'
742         _program_exec_restartable_loop_operation__routine ()
743         {
744                 local tag dbpath origin suffix
745                 tag=${_REQUIREMENT_LISTS_tag}
746                 dbpath=$1
747                 origin=`str_dirpath_to_origin "$dbpath"`
748                 for suffix in '' .orig
749                 do
750                         database_build_get_complete_recursive_dependency requirements.${tag} "$origin" "$suffix" > /dev/null
751                 done
752         }
753         _program_exec_and_record_completion__operation ()
754         {
755                 local tag
756                 tag=${_REQUIREMENT_LISTS_tag}
757                 message_section_title "Completion of ${tag}-time requirement lists"
758                 program_exec_restartable_loop_operation complete_recursive_${tag}time_reqlists
759                 message_echo
760         }
761         program_exec_and_record_completion RECURSIVE_REQUIREMENT_LISTS:${_REQUIREMENT_LISTS_tag}
762 done
763
764 # Trim dependency lists by removing uninspected ports
765 if [ $opt_only_target_scope = yes ]
766 then
767         PROGRAM_DEPENDS='INSPECT_ALL_DEPENDENCIES CONVERT_REQUIREMENTS_LIST'
768         _program_exec_restartable_loop_operation__routine ()
769         {
770                 local dbpath tag level srcdb
771                 dbpath=$1
772                 for tag in all run build
773                 do
774                         for level in direct full
775                         do
776                                 srcdb=requirements.${tag}.${level}
777                                 [ -e "$dbpath/$srcdb" ] || continue
778                                 grep -E -f "${DBDIR}/inspected_ports.grep_pattern" "$dbpath/$srcdb" \
779                                         > $dbpath/$srcdb.tmp || :
780                                 mv "$dbpath/$srcdb.tmp" "$dbpath/$srcdb"
781                         done
782                 done
783         }
784         _program_exec_and_record_completion__operation ()
785         {
786                 message_section_title "Trimming dependency lists by removing uninspected ports"
787                 program_exec_restartable_loop_operation trim_dependency_lists_rm_uninspected_ports
788                 message_echo
789         }
790         program_exec_and_record_completion TRIM_DEPENDENCY_LISTS_RM_UNINSPECTED_PORTS
791 fi
792
793 # Inspection of dependents
794 PROGRAM_DEPENDS='INSPECT_ALL_DEPENDENCIES CONVERT_REQUIREMENTS_LIST TRIM_DEPENDENCY_LISTS_RM_UNINSPECTED_PORTS'
795 _program_exec_restartable_loop_operation__routine ()
796 {
797         local dbpath origin tag level suffix srcdb dstdb
798         dbpath=$1
799         origin=`str_dirpath_to_origin "$dbpath"`
800         for tag in all run build
801         do
802                 for level in direct full
803                 do
804                         for suffix in '' .orig
805                         do
806                                 srcdb=requirements.${tag}.${level}${suffix}
807                                 dstdb=dependents.${tag}.${level}${suffix}
808                                 [ -e "$dbpath/$srcdb" ] || continue
809                                 while read origin_requirement
810                                 do
811                                         dstpath=${DBDIR}/requires/$origin_requirement
812                                         echo "$dstpath/$dstdb" >> ${DBDIR}/dependents_files.tmp
813                                         [ "$dstpath/$dstdb" -nt "$dbpath/$srcdb" ] && continue
814                                         [ -d "$dstpath" ] || mkdir -p "$dstpath"
815                                         echo "$origin" >> $dstpath/$dstdb.raw
816                                         echo "$dstpath/$dstdb" >> ${DBDIR}/stage.loop_list/make_dependents_lists_unique.tmp
817                                 done < $dbpath/$srcdb
818                         done
819                 done
820         done
821 }
822 _program_exec_and_record_completion__operation ()
823 {
824         local dbrequires_valesc
825         message_section_title "Inspection of dependents"
826         dbrequires_valesc=`str_escape_replaceval "${DBDIR}/requires/"`
827         program_exec_restartable_loop_operation inspect_dependent
828         sort -u "${DBDIR}/stage.loop_list/make_dependents_lists_unique.tmp" 2> /dev/null \
829                 > ${DBDIR}/stage.loop_list/make_dependents_lists_unique || :
830         sort -u "${DBDIR}/dependents_files.tmp" 2> /dev/null > ${DBDIR}/dependents_files || :
831         [ -e "${DBDIR}/make_dependents_lists_unique.prev" ] && \
832                 fileedit_manipulate_old_lines "${DBDIR}/dependents_files.prev" "${DBDIR}/dependents_files" \
833                 | xargs rm -f
834         message_echo
835 }
836 program_exec_and_record_completion INSPECT_DEPENDENTS
837
838 # Remove duplicated lines in dependents lists
839 PROGRAM_DEPENDS='CONVERT_REQUIREMENTS_LIST INSPECT_DEPENDENTS'
840 _program_exec_restartable_loop_operation__routine ()
841 {
842         local dbpath tag level dstdb
843         dstdb=$1
844         cat "$dstdb" "$dstdb.raw" 2> /dev/null | sort -u > $dstdb.tmp
845         mv "$dstdb.tmp" "$dstdb"
846         rm -f "$dstdb.raw"
847 }
848 _program_exec_and_record_completion__operation ()
849 {
850         local dbrequires_valesc
851         message_section_title "Removing duplicated items in dependents lists"
852         program_exec_restartable_loop_operation make_dependents_lists_unique
853         message_echo
854 }
855 program_exec_and_record_completion MAKE_DEPENDENTS_LISTS_UNIQUE
856
857 # Preparation of target attribute information
858 for _TARGET_ATTR_INFO_table in requirements dependents itself
859 do
860         [ `cat "${DBDIR}/stage.loop_list/target_${_TARGET_ATTR_INFO_table}.replaced.specified" 2> /dev/null \
861                 | wc -l` -gt 0 ] || continue
862         PROGRAM_DEPENDS='DETERMINE_SPECIFIED_TARGETS CONVERT_REQUIREMENTS_LIST'
863         _program_exec_restartable_loop_operation__routine ()
864         {
865                 local origin dbtargets_valesc table
866                 origin=$1
867                 dbtargets_valesc=`str_escape_replaceval "${DBDIR}/targets/"`
868                 table=${_TARGET_ATTR_INFO_table}
869                 for database in requires initial
870                 do
871                         dbpath=${DBDIR}/$database/$origin
872                         dstpath=${DBDIR}/targets/$origin
873                         [ -d "$dstpath" ] || mkdir -p "$dstpath"
874                         touch "$dstpath/target_itself"
875                         echo "$origin" >> ${DBDIR}/all_targets.lst
876                         [ $table = itself ] && continue
877                         for tag in all run build
878                         do
879                                 for level in direct full
880                                 do
881                                         srcdb=${table}.${tag}.${level}
882                                         dstdb=target_${database}_${table}.${tag}.${level}
883                                         [ -e "$dbpath/$srcdb" ] || continue
884                                         cat "$dbpath/$srcdb" >> ${DBDIR}/all_targets.lst
885                                         sed -E "s/^/$dbtargets_valesc/; s|$|/$dstdb|" "$dbpath/$srcdb" \
886                                                 | fileedit_add_a_line_to_files_if_new "$origin"
887                                 done
888                         done
889                 done
890         }
891         _program_exec_and_record_completion__operation ()
892         {
893                 local table
894                 table=${_TARGET_ATTR_INFO_table}
895                 message_section_title "Preparation of target attribute information for dependency [$table]"
896                 program_exec_restartable_loop_operation target_$table.replaced.specified
897                 message_echo
898         }
899         program_exec_and_record_completion TARGET_ATTR_INFO:${_TARGET_ATTR_INFO_table}
900 done
901
902 # Post-process after the preparation of target attribute information
903 PROGRAM_DEPENDS='MAKE_DEPENDENTS_LISTS_UNIQUE TARGET_ATTR_INFO:requirements TARGET_ATTR_INFO:dependents'
904 _program_exec_and_record_completion__operation ()
905 {
906         message_section_title "Post-process after the preparation of target attribute information"
907         sort -u "${DBDIR}/all_targets.lst" 2> /dev/null \
908                 | grep -E -f "${DBDIR}/inspected_ports.grep_pattern" \
909                 | sed -E -f "${DBDIR}/REPLACE.complete_sed_pattern" \
910                 > ${DBDIR}/all_targets.lst.tmp || :
911         mv "${DBDIR}/all_targets.lst.tmp" "${DBDIR}/all_targets.lst"
912         find "${DBDIR}/targets" -depth 2 -type d > ${DBDIR}/stage.loop_list/build_complement_to_new_dependents_for_targets 2> /dev/null || :
913         {
914                 cat "${DBDIR}/all_targets.lst" "${DBDIR}/need.with_replaced.list" 2> /dev/null || :
915                 find "${DBDIR}/requires" -depth 3 -type f -name installed_version \
916                         | sed -E 's|.*/([^/]+/[^/]+)/[^/]*$|\1|'
917         } | sort -u > ${DBDIR}/stage.loop_list/inspect_necessity
918         cp /dev/null "${DBDIR}/stage.loop_list/parse_target_attr_info"
919         find -E "${DBDIR}/requires" -depth 3 -type f -regex '.*/necessary_port\.(direct|full)$' -delete
920         message_echo
921 }
922 program_exec_and_record_completion TARGET_ATTR_INFO_POSTPROCESS
923
924 # Build of data on complement to new dependents for target attribute information
925 PROGRAM_DEPENDS='TARGET_ATTR_INFO_POSTPROCESS TARGET_ATTR_INFO:requirements TARGET_ATTR_INFO:dependents CONVERT_REQUIREMENTS_LIST'
926 _program_exec_restartable_loop_operation__routine ()
927 {
928         local dbpath origin
929         dbpath=$1
930         origin=`str_dirpath_to_origin "$dbpath"`
931         database_build_complement_to_new_dependents_for_targets "$origin"
932 }
933 _program_exec_and_record_completion__operation ()
934 {
935         message_section_title "Build of data on complement to new dependents for target attribute information"
936         program_exec_restartable_loop_operation build_complement_to_new_dependents_for_targets
937         sort -u "${DBDIR}/stage.loop_list/parse_target_attr_info" > ${DBDIR}/stage.loop_list/parse_target_attr_info.tmp
938         mv "${DBDIR}/stage.loop_list/parse_target_attr_info.tmp" "${DBDIR}/stage.loop_list/parse_target_attr_info"
939         message_echo
940 }
941 program_exec_and_record_completion COMPLEMENT_TO_NEW_DEPENDENTS_FOR_TARGET_ATTR_INFO
942
943 # Parse target attribute information
944 PROGRAM_DEPENDS='COMPLEMENT_TO_NEW_DEPENDENTS_FOR_TARGET_ATTR_INFO'
945 _program_exec_restartable_loop_operation__routine ()
946 {
947         local dbpath origin
948         dbpath=$1
949         origin=`str_dirpath_to_origin "$dbpath"`
950         database_build_target_attributes "$origin"
951 }
952 _program_exec_and_record_completion__operation ()
953 {
954         message_section_title "Parsing target attribute information"
955         program_exec_restartable_loop_operation parse_target_attr_info
956         message_echo
957 }
958 program_exec_and_record_completion PARSE_TARGET_ATTR_INFO
959
960 # Inspection of necessity
961 PROGRAM_DEPENDS='TARGET_ATTR_INFO_POSTPROCESS RECURSIVE_REQUIREMENT_LISTS:run RECURSIVE_REQUIREMENT_LISTS:build INSPECT_ALL_DEPENDENCIES'
962 _program_exec_restartable_loop_operation__routine ()
963 {
964         local origin
965         origin=$1
966         for level in direct full
967         do
968                 database_build_inspect_necessity_for_only_new_upgrade "$origin" "$level"
969         done
970 }
971 _program_exec_and_record_completion__operation ()
972 {
973         message_section_title "Inspection of necessity"
974         program_exec_restartable_loop_operation inspect_necessity
975         for level in direct full
976         do
977                 find "${DBDIR}/requires" -depth 3 -type f -name "necessary_port.${level}" \
978                         > ${DBDIR}/stage.loop_list/necessary_ports.${level}
979         done
980         message_echo
981 }
982 program_exec_and_record_completion INSPECT_NECESSITY
983
984 # Inspection of necessary upgrades
985 for _NECESSARY_UPDATES_level in direct full
986 do
987         PROGRAM_DEPENDS='INSPECT_NECESSITY INSPECT_ALL_DEPENDENCIES MAKE_DEPENDENTS_LISTS_UNIQUE'
988         _program_exec_restartable_loop_operation__routine ()
989         {
990                 local markerpath level dbpath origin tag
991                 markerpath=$1
992                 level=${_NECESSARY_UPDATES_level}
993                 dbpath=`dirname "$markerpath"`
994                 origin=`str_dirpath_to_origin "$dbpath"`
995                 database_query_does_a_port_need_update "$origin" || return 0
996                 for tag in all run build none
997                 do
998                         touch "$dbpath/necessary_upgrade.$tag.${level}"
999                         [ -e "$dbpath/dependents.$tag.${level}" ] || continue
1000                         while read origin_dependent
1001                         do
1002                                 touch "${DBDIR}/requires/$origin_dependent/necessary_upgrade.$tag.${level}"
1003                         done < $dbpath/dependents.$tag.${level}
1004                 done
1005         }
1006         _program_exec_and_record_completion__operation ()
1007         {
1008                 local level
1009                 level=${_NECESSARY_UPDATES_level}
1010                 message_section_title "Inspection of necessary upgrades at the $level level"
1011                 program_exec_restartable_loop_operation necessary_ports.${level}
1012                 message_echo
1013         }
1014         program_exec_and_record_completion NECESSARY_UPDATES:${_NECESSARY_UPDATES_level}
1015 done
1016
1017 # Preparation for inspection of new leaf ports
1018 if [ ! -e "${DBDIR}/inspected_ports_only_partially" ]
1019 then
1020         PROGRAM_DEPENDS='INSPECT_ALL_DEPENDENCIES MAKE_DEPENDENTS_LISTS_UNIQUE PARSE_CONF'
1021         _program_exec_and_record_completion__operation ()
1022         {
1023                 message_section_title "Preparation for inspection of new leaf ports"
1024                 find "${DBDIR}/requires" -depth 3 -type f -name dependents.all.full \
1025                         | sed -E 's|.*/([^/]+/[^/]+)/[^/]+$|\1|' \
1026                         | sort -u > ${TMPDIR}/PREPARE_INSPECT_LEAF_PORTS:nonleaf_ports
1027                 sort -u "${DBDIR}/inspected_ports" > ${TMPDIR}/PREPARE_INSPECT_LEAF_PORTS:inspected_ports
1028                 fileedit_manipulate_new_lines \
1029                         "${TMPDIR}/PREPARE_INSPECT_LEAF_PORTS:nonleaf_ports" \
1030                         "${TMPDIR}/PREPARE_INSPECT_LEAF_PORTS:inspected_ports" \
1031                         | grep -v -E -f "${DBDIR}/conf/HOLD_PORTS.grep_pattern" \
1032                         > ${DBDIR}/stage.loop_list/leaf_ports_primary_candidates || :
1033                 cp /dev/null "${DBDIR}/grep.leaf_ports.pattern"
1034                 cp /dev/null "${DBDIR}/stage.loop_list/leaf_ports_secondary_candidates"
1035                 message_echo
1036         }
1037         program_exec_and_record_completion PREPARE_INSPECT_LEAF_PORTS
1038 fi
1039
1040 # Inspection of new primary leaf ports
1041 if [ ! -e "${DBDIR}/inspected_ports_only_partially" ]
1042 then
1043         PROGRAM_DEPENDS='INSPECT_ALL_DEPENDENCIES MAKE_DEPENDENTS_LISTS_UNIQUE PREPARE_INSPECT_LEAF_PORTS PARSE_CONF'
1044         _program_exec_restartable_loop_operation__routine ()
1045         {
1046                 local origin origin_ini origin_esc dbpath origin_req
1047                 origin=$1
1048                 pkgsys_is_pkgtool "$origin" && return
1049                 dbpath=${DBDIR}/requires/$origin
1050                 origin_esc=`str_escape_regexp "$origin"`
1051                 grep -q -E "^$origin_esc$" "${DBDIR}/need.with_replaced.list" 2> /dev/null && return
1052                 if ! grep -q -E "^$origin_esc$" "${DBDIR}/noneed.list" 2> /dev/null
1053                 then
1054                         if [ -e "$dbpath/initial_orig" ]
1055                         then
1056                                 origin_ini=`cat "$dbpath/initial_orig"`
1057                                 [ -e "${DBDIR}/initial/$origin_ini/installed_version" \
1058                                         -a `cat "${DBDIR}/initial/$origin_ini/dependents.all.full" 2> /dev/null | wc -l` -eq 0 ] \
1059                                         && return
1060                         fi
1061                         [ -e "${DBDIR}/initial/$origin/installed_version" \
1062                                 -a `cat "${DBDIR}/initial/$origin/dependents.all.full" 2> /dev/null | wc -l` -eq 0 ] \
1063                                 && return
1064                 fi
1065                 if [ -e "$dbpath/requirements.all.full" ]
1066                 then
1067                         grep -v -E -f "${DBDIR}/conf/HOLD_PORTS.grep_pattern" "$dbpath/requirements.all.full" | \
1068                                 fileedit_add_lines_if_new "${DBDIR}/stage.loop_list/leaf_ports_secondary_candidates" || :
1069                 fi
1070                 fileedit_add_a_line_if_new "^$origin_esc$" "${DBDIR}/grep.leaf_ports.pattern"
1071         }
1072         _program_exec_and_record_completion__operation ()
1073         {
1074                 local num_leaves num_leaves_prev
1075                 message_section_title "Inspection of new primary leaf ports"
1076                 program_exec_restartable_loop_operation leaf_ports_primary_candidates
1077                 wc -l < ${DBDIR}/grep.leaf_ports.pattern | tr -d ' ' > ${DBDIR}/num_leaves
1078                 cp /dev/null "${DBDIR}/leaf_ports_secondary_candidates.new_requirements"
1079                 message_echo "  `cat "${DBDIR}/num_leaves"` primary leaf port(s) is/are found."
1080                 message_echo
1081         }
1082         program_exec_and_record_completion INSPECT_PRIMARY_LEAF_PORTS
1083 fi
1084
1085 # Inspection of requirements of new leaf ports
1086 if [ ! -e "${DBDIR}/inspected_ports_only_partially" ]
1087 then
1088         PROGRAM_DEPENDS='INSPECT_ALL_DEPENDENCIES MAKE_DEPENDENTS_LISTS_UNIQUE INSPECT_PRIMARY_LEAF_PORTS PARSE_CONF'
1089         _program_exec_and_record_completion__operation ()
1090         {
1091                 local num_leaves num_leaves_prev num_inspect num_leaves_new
1092                 message_section_title "Inspection of requirements of new leaf ports"
1093                 message_echo "INFO: The inspection proceeds by iterative method."
1094                 while :
1095                 do
1096                         _program_exec_restartable_loop_operation__routine ()
1097                         {
1098                                 local origin origin_esc dbpath
1099                                 origin=$1
1100                                 pkgsys_is_pkgtool "$origin" && return
1101                                 dbpath=${DBDIR}/requires/$origin
1102                                 origin_esc=`str_escape_regexp "$origin"`
1103                                 grep -q -E "^$origin_esc$" "${DBDIR}/need.with_replaced.list" 2> /dev/null && return
1104                                 grep -E -v -f "${DBDIR}/grep.leaf_ports.pattern" \
1105                                         "$dbpath/dependents.all.full" > /dev/null 2>&1 && return
1106                                 cat "$dbpath/requirements.all.full" 2> /dev/null \
1107                                         >> ${DBDIR}/leaf_ports_secondary_candidates.new_requirements || :
1108                                 fileedit_add_a_line_if_new "^$origin_esc$" "${DBDIR}/grep.leaf_ports.pattern"
1109                         }
1110                         program_exec_restartable_loop_operation leaf_ports_secondary_candidates
1111                         num_leaves_prev=`cat "${DBDIR}/num_leaves"`
1112                         num_leaves=`wc -l < ${DBDIR}/grep.leaf_ports.pattern | tr -d ' '`
1113                         num_leaves_new=`echo $(($num_leaves-$num_leaves_prev)) | tr -d ' '`
1114                         if [ $num_leaves_new -eq 0 ]
1115                         then
1116                                 message_echo "  No more leaf port is found."
1117                                 message_echo "  $num_leaves leaf port(s) is/are found in total."
1118                                 break
1119                         fi
1120                         {
1121                                 grep -E -v -f "${DBDIR}/grep.leaf_ports.pattern" \
1122                                         "${DBDIR}/stage.loop_list/leaf_ports_secondary_candidates" || :
1123                                 cat "${DBDIR}/leaf_ports_secondary_candidates.new_requirements" || :
1124                         } | grep -v -E -f "${DBDIR}/conf/HOLD_PORTS.grep_pattern" | sort -u \
1125                                 > ${DBDIR}/stage.loop_list/leaf_ports_secondary_candidates.tmp || :
1126                         program_reset_loop_for_stage INSPECT_REQUIREMENTS_OF_LEAF_PORTS
1127                         mv "${DBDIR}/stage.loop_list/leaf_ports_secondary_candidates.tmp" \
1128                                 "${DBDIR}/stage.loop_list/leaf_ports_secondary_candidates"
1129                         cp /dev/null "${DBDIR}/leaf_ports_secondary_candidates.new_requirements"
1130                         echo "$num_leaves" > ${DBDIR}/num_leaves
1131                         num_inspect=`wc -l < ${DBDIR}/stage.loop_list/leaf_ports_secondary_candidates | tr -d ' '`
1132                         message_echo "  $num_leaves_new leaf port(s) is/are newly found; continue for $num_inspect candidate(s)."
1133                 done
1134                 grep -E -f "${DBDIR}/grep.leaf_ports.pattern" "${DBDIR}/inspected_ports" | sort -u > ${DBDIR}/leaf_ports || :
1135                 message_echo
1136         }
1137         program_exec_and_record_completion INSPECT_REQUIREMENTS_OF_LEAF_PORTS
1138 fi
1139
1140 # Order the ports considering dependencies
1141 PROGRAM_DEPENDS='CONVERT_REQUIREMENTS_LIST'
1142 _program_exec_and_record_completion__operation ()
1143 {
1144         message_section_title "Ordering dependencies"
1145         if ! database_build_order_ports_considering_dependencies
1146         then
1147                 message_echo "ERROR: Unsatisfied dependencies are remained:" >&2
1148                 message_cat "${DBDIR}/unsatisfied.list"
1149                 message_echo "*** Aborted by ${APPNAME}"
1150                 message_echo "The ports tree seems broken. You might have caught an incomplete version."
1151                 message_echo "You are encouraged to update the ports tree by portsnap(8)."
1152                 message_echo "Then execute"
1153                 message_echo " ${APPNAME} clean"
1154                 message_echo "before restart."
1155                 temp_terminate_process () { :; }
1156                 exit 1
1157         fi
1158         message_echo
1159 }
1160 program_exec_and_record_completion ORDER_ALL_DEPENDENCIES
1161
1162 # Selection of removing leaf ports
1163 PROGRAM_DEPENDS='INSPECT_REQUIREMENTS_OF_LEAF_PORTS'
1164 _program_exec_and_record_completion__operation ()
1165 {
1166         message_section_title "Selection of removing leaf ports"
1167         deinstall_select_leaf_ports_to_delete
1168         message_echo
1169 }
1170 program_exec_and_record_completion SELECT_LEAF_PORTS
1171
1172 # Selection of removing obsolete ports
1173 PROGRAM_DEPENDS='INSPECT_ALL_DEPENDENCIES PARSE_CONF'
1174 _program_exec_and_record_completion__operation ()
1175 {
1176         message_section_title "Selection of removing obsolete ports"
1177         deinstall_select_obsolete_ports_to_delete
1178         message_echo
1179 }
1180 program_exec_and_record_completion SELECT_OBSOLETE_PORTS
1181
1182 # Collection of leaf ports to delete
1183 if [ ! -e "${DBDIR}/inspected_ports_only_partially" ]
1184 then
1185         PROGRAM_DEPENDS='SELECT_LEAF_PORTS'
1186         _program_exec_and_record_completion__operation ()
1187         {
1188                 local src src_unselected reqptn_file src_with_initial_origins
1189                 message_section_title "Collecting leaf ports to delete"
1190                 src=${DBDIR}/leaf_ports
1191                 src_unselected=${DBDIR}/leaf_ports_to_delete.unselected
1192                 src_with_initial_origins=${DBDIR}/leaf_ports.with_ini
1193                 reqptn_file=${DBDIR}/leaf_ports.requirements_of_unselected.grep_pattern
1194                 cat "$src_unselected" 2> /dev/null | while read origin
1195                 do
1196                         cat "${DBDIR}/requires/$origin/requirements.all.full" || :
1197                 done | sort -u | str_escape_regexp_filter \
1198                         | sed 's/^/^/;s/$/$/' > $reqptn_file
1199                 database_query_add_initial_origins < $src > $src_with_initial_origins
1200                 message_echo
1201         }
1202         program_exec_and_record_completion COLLECT_LEAF_PORTS_TO_DELETE
1203 fi
1204
1205 # Collection of obsolete ports to delete
1206 PROGRAM_DEPENDS='SELECT_OBSOLETE_PORTS'
1207 _program_exec_and_record_completion__operation ()
1208 {
1209         local src src_selected src_unselected dst_selected reqptn_file
1210         message_section_title "Collecting obsolete ports to delete"
1211         src=${DBDIR}/obsolete_ports.can_be_deleted
1212         src_selected=${DBDIR}/obsolete_ports_to_delete.selected
1213         src_unselected=${DBDIR}/obsolete_ports_to_delete.unselected
1214         dst_selected=${DBDIR}/obsolete_ports_to_delete
1215         reqptn_file=${DBDIR}/obsolete_ports.requirements_of_unselected.grep_pattern
1216         cat "$src_unselected" 2> /dev/null | while read origin
1217         do
1218                 cat "${DBDIR}/initial/$origin/requirements.run.full" || :
1219                 cat "${DBDIR}/obsolete/$origin/requirements.run.full" || :
1220         done | sort -u | str_escape_regexp_filter \
1221                 | sed 's/^/^/;s/$/$/' > $reqptn_file
1222         grep -v -E -f "$reqptn_file" "$src_selected" > $dst_selected 2> /dev/null || :
1223         message_echo
1224 }
1225 program_exec_and_record_completion COLLECT_OBSOLETE_PORTS_TO_DELETE
1226
1227 # Set up the list of ports to reinstall
1228 PROGRAM_DEPENDS='ORDER_ALL_DEPENDENCIES'
1229 _program_exec_and_record_completion__operation ()
1230 {
1231         message_section_title "Setting up the list of ports to reinstall"
1232         cp -p "${DBDIR}/reinst_order.list" "${DBDIR}/stage.loop_list/reinst_todo"
1233         message_echo
1234 }
1235 program_exec_and_record_completion SETUP_REINST_TODO
1236
1237 # Composition of a list for deinstallation of obsolete and leaf packages
1238 PROGRAM_DEPENDS='COLLECT_LEAF_PORTS_TO_DELETE COLLECT_OBSOLETE_PORTS_TO_DELETE'
1239 _program_exec_and_record_completion__operation ()
1240 {
1241         local reqptn_leaf reqptn_obs leaf_selected leaf_selected_src obs_selected obs_selected_src grepptn preserved
1242         message_section_title "Composing a list for deinstallation of obsolete and leaf packages"
1243         reqptn_leaf=${DBDIR}/leaf_ports.requirements_of_unselected.grep_pattern
1244         reqptn_obs=${DBDIR}/obsolete_ports.requirements_of_unselected.grep_pattern
1245         leaf_selected_src=${DBDIR}/leaf_ports_to_delete.selected
1246         leaf_selected=${DBDIR}/leaf_ports_to_delete
1247         obs_selected_src=${DBDIR}/obsolete_ports_to_delete.selected
1248         obs_selected=${DBDIR}/obsolete_ports_to_delete
1249         grepptn=${DBDIR}/ports_to_delete.grep_pattern
1250         grepptn_col1=${DBDIR}/ports_to_delete.grep_pattern_col1
1251         preserved=${TMPDIR}/LIST_DEINST_PKGS::preserved
1252         if [ ! -e "${DBDIR}/inspected_ports_only_partially" ]
1253         then
1254                 cat "$reqptn_leaf" "$reqptn_obs" 2> /dev/null | sort -u > $grepptn
1255                 grep -v -E -f "$grepptn" "$leaf_selected_src" 2> /dev/null \
1256                         | database_query_add_initial_origins > $leaf_selected || :
1257                 cat "$obs_selected" "$leaf_selected" 2> /dev/null || :
1258         else
1259                 rm -f "$leaf_selected"
1260                 cat "$obs_selected" 2> /dev/null
1261         fi | sort -u > ${DBDIR}/stage.loop_list/ports_to_delete
1262         str_escape_regexp_filter < ${DBDIR}/stage.loop_list/ports_to_delete \
1263                 | sed 's/^/^/;s/$/$/' > $grepptn
1264         str_escape_regexp_filter < ${DBDIR}/stage.loop_list/ports_to_delete \
1265                 | sed 's/^/^/;s/$/[[:space:]]/' > $grepptn_col1
1266         cat "${DBDIR}/leaf_ports.with_ini" "${DBDIR}/obsolete_ports" 2> /dev/null \
1267                 | grep -E -v -f "$grepptn" > ${DBDIR}/stage.loop_list/ports_to_restore || :
1268         if [ $opt_batch_mode = no ]
1269         then
1270                 if [ ! -e "${DBDIR}/inspected_ports_only_partially" ] && \
1271                         grep -v -E -f "$grepptn" "$leaf_selected_src" > $preserved 2> /dev/null
1272                 then
1273                         message_echo "INFO: Following leaf ports are preserved because required by other preserved leaf/obsolete ports."
1274                         message_echo "----------------"
1275                         while read origin
1276                         do
1277                                 pkgtag=`cat "${DBDIR}/required/$origin/pkgtag" 2> /dev/null` || :
1278                                 if [ -n "$pkgtag" ]
1279                                 then
1280                                         echo "$origin" "($pkgtag)"
1281                                 else
1282                                         echo "$origin"
1283                                 fi
1284                         done < $preserved
1285                         message_echo "----------------"
1286                 fi
1287                 if grep -v -E -f "$grepptn" "$obs_selected_src" > $preserved 2> /dev/null
1288                 then
1289                         message_echo "INFO: Following obsolete ports are preserved because required by other obsolete ports."
1290                         message_echo "----------------"
1291                         while read origin
1292                         do
1293                                 pkgtag=`cat "${DBDIR}/initial/$origin/installed_version" 2> /dev/null` || :
1294                                 if [ -n "$pkgtag" ]
1295                                 then
1296                                         echo "$origin" "($pkgtag)"
1297                                 else
1298                                         echo "$origin"
1299                                 fi
1300                         done < $preserved
1301                         message_echo "----------------"
1302                 fi
1303         fi
1304         message_echo
1305 }
1306 program_exec_and_record_completion LIST_DEINST_PKGS
1307
1308 # Collect entire distfiles list
1309 if [ $opt_inspect_entire_distinfo = yes ]
1310 then
1311         PROGRAM_DEPENDS=''
1312         _program_exec_and_record_completion__operation ()
1313         {
1314                 message_section_title "Collecting entire distfiles list"
1315                 find "${PORTSDIR}" -depth 3 -name distinfo -exec cat {} \; \
1316                         | grep '^SHA256 ' | sed -E 's/^SHA256 \(([^)]*)\).*/\1/' \
1317                         | sort -u > ${DBDIR}/distfiles.entire.tmp
1318                 mv "${DBDIR}/distfiles.entire.tmp" "${DBDIR}/distfiles.entire"
1319                 message_echo
1320         }
1321         program_exec_and_record_completion COLLECT_ALL_DISTFILES_LIST
1322 fi
1323
1324 # Inspection of all required distfiles
1325 PROGRAM_DEPENDS='INSPECT_ALL_DEPENDENCIES COLLECT_ALL_DISTFILES_LIST'
1326 _program_exec_and_record_completion__operation ()
1327 {
1328         message_section_title "Summarizing distfiles list"
1329         cat "${DBDIR}/distfiles.entire" "${DBDIR}/distfiles.inspected" 2> /dev/null \
1330                 | sort -u | str_escape_regexp_filter \
1331                 | sed 's|^|^\\.\\/|; s|$|$|' > ${DBDIR}/distfiles.grep.pattern || :
1332         message_echo
1333 }
1334 program_exec_and_record_completion DISTFILES_LIST
1335
1336 # Clean up of reinstallation status for preparation
1337 PROGRAM_DEPENDS='REDO_INIT INSPECT_ALL_DEPENDENCIES'
1338 _program_exec_and_record_completion__operation ()
1339 {
1340         message_section_title "Cleaning up of reinstallation status for preparation"
1341         rm -rf "${DBDIR}/status.ports"
1342         message_echo
1343 }
1344 program_exec_and_record_completion CLEANUP_REINST_STATUS
1345
1346 # Completion of building the temporary database
1347 PROGRAM_DEPENDS='REDO_INIT SETUP_REINST_TODO CLEANUP_REINST_STATUS PARSE_CONF INSPECT_ALL_DEPENDENCIES NECESSARY_UPDATES:direct NECESSARY_UPDATES:full PARSE_TARGET_ATTR_INFO MAKE_DEPENDENTS_LISTS_UNIQUE COLLECT_LEAF_PORTS_TO_DELETE'
1348 _program_exec_and_record_completion__operation ()
1349 {
1350         message_section_title "The temporary database is completely built up"
1351         message_echo
1352 }
1353 program_exec_and_record_completion PREPARATION
1354
1355
1356 # ==================================================
1357 # ====================== MAIN ======================
1358 # ==================================================
1359
1360 # Execute command operations which must be done before actual (re/de)installation processes
1361 command_exec_before_actual_re_de_installation "$@"
1362
1363 # Set termination messages
1364 temp_terminate_process ()
1365 {
1366         temp_terminate_process_common
1367 }
1368
1369 # Reinstallation of remained ports
1370 PROGRAM_DEPENDS='PREPARATION'
1371 _program_exec_restartable_loop_operation__routine ()
1372 {
1373         reinstall_exec "$@"
1374 }
1375 _program_exec_and_record_completion__operation ()
1376 {
1377         local _MSG_CURRENT_STAGE_general
1378         _MSG_CURRENT_STAGE_general="reinstallation"
1379         temp_set_msg_current_stage "${_MSG_CURRENT_STAGE_general}"
1380         message_section_title "Reinstallation"
1381         program_exec_restartable_loop_operation reinst_todo
1382         reinstall_restore_conflicts
1383         temp_set_msg_current_stage
1384         message_echo
1385 }
1386 program_exec_and_record_completion REINSTALLATION
1387
1388 # Restoration of obsolete and leaf packages which have been deinstalled but unselected from the deletion list again 
1389 PROGRAM_DEPENDS='REDO_INIT LIST_DEINST_PKGS'
1390 _program_exec_restartable_loop_operation__routine ()
1391 {
1392         deinstall_restore "$@"
1393 }
1394 _program_exec_and_record_completion__operation ()
1395 {
1396         local _MSG_CURRENT_STAGE_general
1397         _MSG_CURRENT_STAGE_general="restoration of unselected obsolete/leaf packages"
1398         temp_set_msg_current_stage "${_MSG_CURRENT_STAGE_general}"
1399         message_section_title "Restoration of unselected obsolete/leaf packages"
1400         program_exec_restartable_loop_operation ports_to_restore
1401         temp_set_msg_current_stage
1402         message_echo
1403 }
1404 program_exec_and_record_completion RESTORE_ONCE_DEINST_PKGS
1405
1406 # Deinstallation of unused obsolete and leaf packages
1407 PROGRAM_DEPENDS='REDO_INIT LIST_DEINST_PKGS'
1408 _program_exec_restartable_loop_operation__routine ()
1409 {
1410         deinstall_exec "$@"
1411 }
1412 _program_exec_and_record_completion__operation ()
1413 {
1414         local _MSG_CURRENT_STAGE_general
1415         _MSG_CURRENT_STAGE_general="deinstallation of obsolete/leaf packages"
1416         temp_set_msg_current_stage "${_MSG_CURRENT_STAGE_general}"
1417         message_section_title "Deinstallation of unused obsolete/leaf packages"
1418         program_exec_restartable_loop_operation ports_to_delete
1419         temp_set_msg_current_stage
1420         message_echo
1421 }
1422 program_exec_and_record_completion DEINST_UNUSED_PKGS
1423
1424 # Clean up obsolete or unused distfiles
1425 if [ $opt_only_target_scope = no -a $opt_keep_distfiles = no ]
1426 then
1427         PROGRAM_DEPENDS='REINSTALLATION DISTFILES_LIST'
1428         _program_exec_and_record_completion__operation ()
1429         {
1430                 local tmp_distfiles_exists
1431                 message_section_title "Cleaning up obsolete or unused distfiles"
1432                 tmp_distfiles_exists=${TMPDIR}/CLEANUP_OBSLETE_DISTFILES::distfiles_exists
1433                 [ $opt_dry_run = yes ] && message_echo "INFO: The operations are not actually carried out."
1434                 ( set -e; cd "${DISTDIR}" && find . -type f ) \
1435                         | sed 's|^\./||' | sort -u > $tmp_distfiles_exists
1436                 fileedit_manipulate_old_lines "$tmp_distfiles_exists" "${DBDIR}/distfiles.entire" \
1437                         | while read distfile
1438                 do
1439                         if [ $opt_batch_mode = no ]
1440                         then
1441                                 echo "  $distfile"
1442                         fi
1443                         [ $opt_dry_run = yes ] && continue
1444                         rm -f "${DISTDIR}/$distfile"
1445                 done
1446                 message_echo
1447         }
1448         program_exec_and_record_completion CLEANUP_OBSLETE_DISTFILES
1449 fi
1450
1451 # Rebuild of package database
1452 PROGRAM_DEPENDS='REINSTALLATION RESTORE_ONCE_DEINST_PKGS DEINST_UNUSED_PKGS'
1453 _program_exec_and_record_completion__operation ()
1454 {
1455         which -s pkgdb || return 0
1456         message_section_title "Rebuilding package database for portupgrade"
1457         pkgdb -fu
1458         message_echo
1459 }
1460 program_exec_and_record_completion REBUILD_PKGDB
1461
1462
1463 # ==================================================
1464 # ================ ENDING MESSAGES =================
1465 # ==================================================
1466
1467 # Notice of failures
1468 exists_unresolved_ports=
1469 message_summary_dependents_of_failed_reinstallation failure || exists_unresolved_ports=y
1470 message_summary_dependents_of_failed_reinstallation redo || exists_unresolved_ports=y
1471 message_summary_dependents_of_failed_reinstallation conflict || exists_unresolved_ports=y
1472 [ -n "$exists_unresolved_ports" ] && message_summary_advice_on_manual_solution
1473
1474 # End
1475 temp_terminate_process () { :; }
1476
1477 if [ -z "$exists_unresolved_ports" ]
1478 then
1479         message_section_title "COMPLETELY DONE"
1480         message_echo "- E N D -"
1481 else
1482         message_warn_no_achieved_progress || :
1483         message_section_title "Done with some unresolved problems"
1484         message_echo "- To be continued -"
1485 fi